<template>
  <q-page class="flex justify-center">
    <q-form @submit="terminalStore.saveSettings(terminalId, settingsLocal)" class="flex column text-center" style="flex-basis: 100%">
      <div class="column" style="height:100%">
        <q-banner class="flex col-shrink bg-dark text-white q-mb-lg q-pa-md">
          <strong>Terminal Settings</strong>
        </q-banner>
        <div class="flex col-grow items-start justify-center sensible-width">
          <div class="q-form q-gutter-lg" style="width:100%">
            <q-banner inline-actions class="text-white bg-red">
              For security reasons, if you wish to change any of these settings you MUST print a new terminal.
            </q-banner>
            <q-input v-model="settingsLocal.memo" label="Merchant Name" placeholder="Jim's Cafe" hint="Enter your store name" outlined :rules="[val => !!val || 'Field is required']" readonly />
            <q-input v-model="settingsLocal.payoutAddress" label="Destination Address" placeholder="bitcoincash:..." hint="The Bitcoin Cash Address payments should be sent to" outlined :rules="[val => !!val || 'Must be a valid bitcoincash:... address']" readonly />
            <q-input v-model="settingsLocal.currency" label="Local Currency" placeholder="AUD" hint="The currency that should be used" outlined :rules="[val => !!val || 'Field is required']" readonly />
          </div>
        </div>
        <div class="col-shrink sensible-width">
          <div class="q-pa-sm">
            <q-btn push type="submit" label="Save Settings" color="primary" class="full-width q-pa-md" icon="check_circle" disabled />
          </div>
        </div>
      </div>
    </q-form>
  </q-page>
</template>

<script setup lang="ts">
//-----------------------------------------------------------------------------
// Imports and Framework features
//-----------------------------------------------------------------------------
import { reactive, onMounted } from 'vue'
import { useRoute } from 'vue-router'
import { useQuasar } from 'quasar'
import { useTerminalStore } from '../../stores/terminal-store'
import { storeToRefs } from 'pinia'

import type { Settings } from '../../interfaces'

const $q = useQuasar()
const $route = useRoute()
const terminalStore = useTerminalStore()

//-----------------------------------------------------------------------------
// Constants and Properties
//-----------------------------------------------------------------------------

const terminalId = $route.params.terminalId as string

const { settings } = storeToRefs(terminalStore)

// Make a copy of settings so that we do not accidentally modify our Store.
const settingsLocal = reactive<Settings>(JSON.parse(JSON.stringify(settings.value)))

</script>
